// ColorStars.c - A Ken Long  free "Copy-Paste-Modify" demo.

#define star_H_Size		1
#define star_V_Size		1

Point		gOrigin;
RgnHandle	gOldGrayRgn;		// "The ol' gray bar, she ain't what she 
								// used ta be. Many long years ago!"
short		gOldMBarHeight;
WindowPtr	gWindow;
RGBColor	starRGB;
Rect		starRect;
long int	leftPoint, downPoint;
Rect 		windRect = { 0, 0, 384, 512 };
	
void Initialize(void);
void MakeStar (void);

main()
{
	Initialize();
	
	do {
		MakeStar();
	} while (!Button());
	
}

void Initialize()
{
	EventRecord		event;
	short			count;
	Rect			mBarRect;
	RgnHandle		mBarRgn;
	WindowPtr		gWindow;
	OSErr			error;
	SysEnvRec		theWorld;
	
	error = SysEnvirons(1, &theWorld);
	if (theWorld.hasColorQD == false) 
	{
		SysBeep(50);
		ExitToShell();	/* If no color QD, we must leave. */
	}
	
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
	InitCursor();

	GetDateTime((unsigned long*) &qd.randSeed);

	for (count = 1; count <= 3; ++count)
		EventAvail (everyEvent, &event);
	
	gOldMBarHeight = GetMBarHeight ();
	GetMBarHeight () = 0;

	gWindow = NewCWindow (nil, 
						&screenBits.bounds, 
						 "\p", 
						 true, 
						 plainDBox, 
						(WindowPtr) -1, 
						 false, 
						 0);
		
	SetRect (&mBarRect, 
			  screenBits.bounds.left, 
			  screenBits.bounds.top,
			  screenBits.bounds.right, 
			  screenBits.bounds.top + gOldMBarHeight);

	mBarRgn = NewRgn ();
	RectRgn (mBarRgn, &mBarRect);
	UnionRgn (gWindow->visRgn, mBarRgn, gWindow->visRgn);
	DisposeRgn (mBarRgn);
	SetPort (gWindow);
	FillRect (&gWindow->portRect, black);}

void MakeStar()
{
	RGBColor	starColor;
	Rect		starRect;
	long int	H_Offset, V_Offset;
	long ticks;
	
	starColor.red   = Random();
	starColor.green = Random();
	starColor.blue  = Random();
		
	RGBForeColor (&starColor);

	V_Offset = Random();	
	H_Offset = Random();
	
	V_Offset = ((V_Offset + 32767) * windRect.bottom) / 65536;
	H_Offset = ((H_Offset + 32767) * windRect.right) / 65536;
	
	SetRect (&starRect, 
			  H_Offset, 
			  V_Offset, 
			  H_Offset + star_H_Size, 
			  V_Offset + star_V_Size);
	
	MoveTo(H_Offset, V_Offset);
	PaintRect (&starRect);
	RGBForeColor(&starColor);
	Delay (5L, &ticks);		// Installed to slow things down, some.
}
